"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.it = void 0;
exports.itBase = itBase;
const node_process_1 = require("process");
const each_js_1 = require("../../../configs/each.js");
const indentation_js_1 = require("../../../configs/indentation.js");
const format_js_1 = require("../../../services/format.js");
const write_js_1 = require("../../../services/write.js");
const modifiers_js_1 = require("../modifiers.js");
const get_arg_js_1 = require("../../../parsers/get-arg.js");
const poku_js_1 = require("../../../configs/poku.js");
async function itBase(...args) {
    try {
        let message;
        let cb;
        if (typeof args[0] === 'string') {
            message = args[0];
            cb = args[1];
        }
        else
            cb = args[0];
        if (message) {
            indentation_js_1.indentation.hasItOrTest = true;
            (0, write_js_1.log)(`${indentation_js_1.indentation.hasDescribe ? '  ' : ''}${(0, format_js_1.format)(`◌ ${message}`).dim()}`);
        }
        if (typeof each_js_1.each.before.cb === 'function') {
            const beforeResult = each_js_1.each.before.cb();
            if (beforeResult instanceof Promise)
                await beforeResult;
        }
        const start = (0, node_process_1.hrtime)();
        const resultCb = cb();
        if (resultCb instanceof Promise)
            await resultCb;
        const end = (0, node_process_1.hrtime)(start);
        if (typeof each_js_1.each.after.cb === 'function') {
            const afterResult = each_js_1.each.after.cb();
            if (afterResult instanceof Promise)
                await afterResult;
        }
        if (!message)
            return;
        const total = (end[0] * 1e3 + end[1] / 1e6).toFixed(6);
        indentation_js_1.indentation.hasItOrTest = false;
        (0, write_js_1.log)(`${indentation_js_1.indentation.hasDescribe ? '  ' : ''}${(0, format_js_1.format)(`● ${message}`).success().bold()} ${(0, format_js_1.format)(`› ${total}ms`).success().dim()}`);
    }
    catch (error) {
        indentation_js_1.indentation.hasItOrTest = false;
        if (typeof each_js_1.each.after.cb === 'function') {
            const afterResult = each_js_1.each.after.cb();
            if (afterResult instanceof Promise)
                await afterResult;
        }
        throw error;
    }
}
async function itCore(messageOrCb, cb) {
    if (get_arg_js_1.hasOnly) {
        if (!poku_js_1.GLOBAL.runAsOnly)
            return;
        if (typeof messageOrCb === 'string' && typeof cb === 'function')
            return itBase(messageOrCb, cb);
        if (typeof messageOrCb === 'function')
            return itBase(messageOrCb);
    }
    if (typeof messageOrCb === 'string' && cb)
        return itBase(messageOrCb, cb);
    if (typeof messageOrCb === 'function')
        return itBase(messageOrCb);
}
exports.it = Object.assign(itCore, {
    todo: modifiers_js_1.todo,
    skip: modifiers_js_1.skip,
    only: modifiers_js_1.onlyIt,
});
