"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nodeVersion = exports.getRuntime = void 0;
const node_process_1 = require("process");
const regex = /v(\d+)\./;
const getRuntime = () => {
    if (node_process_1.env.POKU_RUNTIME)
        return node_process_1.env.POKU_RUNTIME;
    if (typeof Deno !== 'undefined')
        return 'deno';
    if (typeof Bun !== 'undefined')
        return 'bun';
    return 'node';
};
exports.getRuntime = getRuntime;
exports.nodeVersion = (0, exports.getRuntime)() === 'node' ? Number(node_process_1.version.match(regex)?.[1]) : undefined;
